#include <iostream>
#include "prefiksno_stablo.h"

using namespace std;

void ispisi(Cvor* koren) {
	if(koren->kraj_reci)
		cout << koren->rec << '\n';
	for(auto p : koren->prelaz)
		ispisi(p.second);
}

void ispisi_prefiks(Cvor* koren, string& s) {
	for(char c : s) {
		if(koren->prelaz.find(c) == koren->prelaz.end())
			return;
		koren = koren->prelaz[c];
	}
	ispisi(koren);
}

int main() {
	Cvor* stablo = new Cvor();

	int n;
	cin >> n;

	string s;
	while(n--) {
		cin >> s;
		dodaj(stablo, s);
	}

	cin >> n;
	while(n--) {
		cin >> s;
		ispisi_prefiks(stablo, s);
	}

	oslobodi(stablo);
	return 0;
}
